// Ex-p5-Blois4
// Pour p5.js
// 3 4 2017
// 
// Utilise: libraries/p5.js
// Utilise: libraries/p5.sound.js
//
// Ouvre, affiche un fichier .txt
// La taille des caractères est liee a l'intensité du son
//
// Touche R Retour au debut
// Touche S Sauve l'ecran (format jpg) dans le dossier du sketch
// Touche T affiche le temps
// Touche Espace Play / Pause
// 
// Origine: Ex-p5-JSON15
//

var NomSon = "Richard_Amelie.wav";
var NomTexte = "Richard_Amelie.txt";
var ligne = 0;
var lignes;
var TempsTexte = new Array(0, 1, 2.4, 6.5, 9.4, 10.2, 10.8, 12.5, 13.6, 14.5, 16.3, 17.5, 18, 18.7, 20.7);

var NomImage1 = "IMG_8982.jpg";
var TempsImage1 = 0; // seconde
var NomImage2 = "IMG_8976.jpg";
var TempsImage2 = 4.6; // seconde
var NomImage3 = "IMG_9002.jpg";
var TempsImage3 = 11.9; // seconde
var NomImage4 = "IMG_9010.jpg";
var TempsImage4 = 17.5; // seconde
var NomImage5 = "IMG_9011.jpg";
var TempsImage5 = 25; // seconde
var NomImage6 = "IMG_8982.jpg";
var TempsImage6 = 26; // seconde
var NomImage7 = "IMG_8976.jpg";
var TempsImage7 = 27; // seconde
var NomImage8 = "IMG_9002.jpg";
var TempsImage8 = 28; // seconde
var NomImage9 = "IMG_9010.jpg";
var TempsImage9 = 29; // seconde
var NomImage10 = "IMG_9011.jpg";
var TempsImage10 = 30; // seconde

var NomTransparent1 = "mask.png";
var TempsTransparent1 = 0; // seconde
var NomTransparent2 = "img-cecile3.png";
var TempsTransparent2 = 3; // seconde
var NomTransparent3 = "goutte.png";
var TempsTransparent3 = 8; // seconde
var NomTransparent4 = "loire.png";
var TempsTransparent4 = 12; // seconde
var NomTransparent5 = "mask.png";
var TempsTransparent5 = 25; // seconde
var NomTransparent6 = "mask.png";
var TempsTransparent6 = 26.5; // seconde
var NomTransparent7 = "img-cecile3.png";
var TempsTransparent7 = 27.5; // seconde
var NomTransparent8 = "goutte.png";
var TempsTransparent8 = 28.5; // seconde
var NomTransparent9 = "loire.png";
var TempsTransparent9 = 29.5; // seconde
var NomTransparent10 = "mask.png";
var TempsTransparent10 = 30.5; // seconde

var TailleTransparentVariable = true; // true   false
var TailleTransparent = 500;

var NomPoliceA = "Pacifico.otf";
var CouleurTextA; // voir dans setup()
var TailleTexteAMin = 50;
var TailleTexteAMax = 50;

var NomPoliceB = "RobotoCondensed-Bold.otf";
var CouleurTextB; // voir dans setup()
var TailleTexteB = 40; // 30
var TexteB = "Amelie..."; 

var AfficheTemps = false;

NomPoliceA = "file/" + NomPoliceA;
NomPoliceB = "file/" + NomPoliceB;
var Son;

var jjjj;

var s = " ";
var rms = 0;

function preload() {
  Son = loadSound("file/" + NomSon);
  PoliceA = loadFont(NomPoliceA);
  PoliceB = loadFont(NomPoliceB);
  image1 = loadImage("file/" + NomImage1);
  image2 = loadImage("file/" + NomImage2);
  image3 = loadImage("file/" + NomImage3);
  image4 = loadImage("file/" + NomImage4);
  image5 = loadImage("file/" + NomImage5);
  image6 = loadImage("file/" + NomImage6);
  image7 = loadImage("file/" + NomImage7);
  image8 = loadImage("file/" + NomImage8);
  image9 = loadImage("file/" + NomImage9);
  image10 = loadImage("file/" + NomImage10);
  Transparent1 = loadImage("file/" + NomTransparent1);
  Transparent2 = loadImage("file/" + NomTransparent2);
  Transparent3 = loadImage("file/" + NomTransparent3);
  Transparent4 = loadImage("file/" + NomTransparent4);
  Transparent5 = loadImage("file/" + NomTransparent5);
  Transparent6 = loadImage("file/" + NomTransparent6);
  Transparent7 = loadImage("file/" + NomTransparent7);
  Transparent8 = loadImage("file/" + NomTransparent8);
  Transparent9 = loadImage("file/" + NomTransparent9);
  Transparent10 = loadImage("file/" + NomTransparent10);
  lignes = loadStrings("file/" + NomTexte);
}

function setup() {
  createCanvas(800, 600);
  CouleurTextA = color(200, 0, 0, 255); // R V B Transparence
  CouleurTextB = color(255, 50, 0);
  analyse = new p5.Amplitude(); // create a new Amplitude analyse
  analyse.setInput(Son);
  Init();
  // frameRate(2);
}

function draw() {
  if (Son.isPlaying()) {
    // background(255, 100);
    for (i = 0; i < TempsTexte.length; i++) {
      if (Son.currentTime() > TempsTexte[i]) ligne = i;
    }

    rms = ((3 * rms) + (analyse.getLevel() * 1000)) / 4; // lissage
    rms = constrain(rms, TailleTexteAMin, TailleTexteAMax);
    // print("rms = " + rms);

    if (Son.currentTime() > TempsImage10) background(image10);
    else if (Son.currentTime() > TempsImage9) background(image9);
    else if (Son.currentTime() > TempsImage8) background(image8);
    else if (Son.currentTime() > TempsImage7) background(image7);
    else if (Son.currentTime() > TempsImage6) background(image6);
    else if (Son.currentTime() > TempsImage5) background(image5);
    else if (Son.currentTime() > TempsImage4) background(image4);
    else if (Son.currentTime() > TempsImage3) background(image3);
    else if (Son.currentTime() > TempsImage2) background(image2);
    else if (Son.currentTime() > TempsImage1) background(image1);

    if (TailleTransparentVariable) TailleTransparent = Son.currentTime() * 100;
    imageMode(CENTER);
    
    if (Son.currentTime() > TempsTransparent10) image(Transparent10, width / 2, height / 2, TailleTransparent, TailleTransparent);
    else if (Son.currentTime() > TempsTransparent9) image(Transparent9, width / 2, height / 2, TailleTransparent, TailleTransparent);
    else if (Son.currentTime() > TempsTransparent8) image(Transparent8, width / 2, height / 2, TailleTransparent, TailleTransparent);
    else if (Son.currentTime() > TempsTransparent7) image(Transparent7, width / 2, height / 2, TailleTransparent, TailleTransparent);
    else if (Son.currentTime() > TempsTransparent6) image(Transparent6, width / 2, height / 2, TailleTransparent, TailleTransparent);
    else if (Son.currentTime() > TempsTransparent5) image(Transparent5, width / 2, height / 2, TailleTransparent, TailleTransparent);
    else if (Son.currentTime() > TempsTransparent4) image(Transparent4, width / 2, height / 2, TailleTransparent, TailleTransparent);
    else if (Son.currentTime() > TempsTransparent3) image(Transparent3, width / 2, height / 2, TailleTransparent, TailleTransparent);
    else if (Son.currentTime() > TempsTransparent2) image(Transparent2, width / 2, height / 2, TailleTransparent, TailleTransparent);
    else if (Son.currentTime() > TempsTransparent1) image(Transparent1, width / 2, height / 2, TailleTransparent, TailleTransparent);

    imageMode(CORNER);

    if (AfficheTemps) Cadre("Time: " + int(Son.currentTime() * 10) / 10 + " seconds", 20, 20, 120);

    textFont(PoliceA);
    textSize(constrain(rms, TailleTexteAMin, TailleTexteAMax));
    textAlign(CENTER, CENTER);
    fill(CouleurTextA);
    text(lignes[ligne], 0, -rms / 2, width - 20, height);
    // print(lignes[ligne]);

    textFont(PoliceB);
    textSize(TailleTexteB);
    // textAlign(LEFT, TOP);
    textAlign(LEFT, BOTTOM);
    fill(CouleurTextB);
    text(TexteB, 10, height - 180, width, 180);
    // print(TexteB + "      " + TexteB); // Console
  }
}

function Cadre(sss, x, y, xx) {
  // textFont('sans-serif');
  textFont(PoliceB);
  textSize(12);
  textAlign(LEFT, TOP);
  fill(255);
  rect(x, y, xx, 20);
  fill(0);
  text(sss, x + 4, y + 3);
}

function Init() {
  Son.stop();
  // Son.loop();
  Son.play();
}

function keyPressed() {
  if (key == 's' || key == 'S') saveCanvas("Screen" + frameCount + '.jpg', 'jpg'); // or png
  if (key == 't' || key == 'T') AfficheTemps = !AfficheTemps;
  if (key == 'r' || key == 'R') Init();
  if (keyCode == 32) {
    if (Son.isPlaying()) Son.pause();
    else Son.play();
  }

}

function windowResized() {
  // resizeCanvas(windowWidth, windowHeight);
  // Init();
}